
/**Clase TicTacToe en donde se implementa el juego del gato*/
public class TicTacToe
{
    private final int cross=1, circle=-1;
    private int winner;
    private static final int nowinner = 2;
    /**instancia del menu del juego*/
    public Menu gameMenu = new Menu();

    private int Columns = 3;
    private int Rows = 3;

    public int totalCheckers = 1;

    TicTacToe()
    {
        initGame();
        //gameCanvas.slots[1][0]=cross;
    }


    /**instancia del gameCanvas*/
    public gameCanvas gameCanvas = new gameCanvas(Columns,Rows)
    {
        protected void keyPressed(int keyCode)//aqui se definen las acciones para los distintos botones
        {
            if(YourTurn || gameEnd){
                switch(keyCode)
                {
                    case KEY_NUM2:
                        MoveUP();
                    break;

                    case KEY_NUM4:
                        MoveLEFT();
                    break;

                    case KEY_NUM5:
                        PUT();
                        //SELECT();
                    break;

                    case KEY_NUM6:
                        MoveRIGHT();
                    break;

                    case KEY_NUM8:
                        MoveDOWN();
                    break;

                    case KEY_NUM0://key 0 to exit
                    Midlet.exit();
                    break;

                    case KEY_NUM1:
                        MoveUP();
                        MoveLEFT();
                    break;

                    case KEY_NUM3:
                        MoveUP();
                        MoveRIGHT();
                    break;

                    case KEY_NUM7:
                        MoveDOWN();
                        MoveLEFT();
                    break;

                    case KEY_NUM9:
                        MoveDOWN();
                        MoveRIGHT();
                    break;

                    /*case KEY_NUM2:
                        goTO(1,0);
                        PUT();
                    break;

                    case KEY_NUM4:
                        goTO(0,1);
                        PUT();
                    break;

                    case KEY_NUM5:
                        goTO(1,1);
                        PUT();
                    break;

                    case KEY_NUM6:
                        goTO(2,1);
                        PUT();
                    break;

                    case KEY_NUM8:
                        goTO(1,2);
                        PUT();
                    break;*/

                }
            repaint();
        }
        }

    };


    private void initGame()
    {
        gameMenu.setGameName("-TIC-TAC-TOE-");//setea el nombre del juego
        gameMenu.setAboutDialog("Sergio Silva - Danny Sateler");//setea el about del juego

    }


    /**verifica quien gana la partida, segun la logica implementada del juego
     @return winner retorna la ficha ganadora*/
    public int CheckWinner(){


        int filled=0;
        for(int row =0;row<Rows;row++)//busca si grilla esta llena, si es asi, nadie gana
        {
            for(int col =0;col<Columns;col++)
            {
                if(gameCanvas.slots[row][col]!=0) filled++;
            }
        }
        if (filled==9) winner=nowinner;


        //comienza a buscar si hay corridas de a 3 con la misma ficha, si es asi se indica que gano
        for(int row =0;row<3;row++)
        {
            if(gameCanvas.slots[row][0]==gameCanvas.slots[row][1] && gameCanvas.slots[row][1]==gameCanvas.slots[row][2])
            {
                winner=gameCanvas.slots[row][0];
            }
        }

        for(int col =0;col<3;col++)
        {
            if(gameCanvas.slots[0][col]==gameCanvas.slots[1][col] && gameCanvas.slots[1][col]==gameCanvas.slots[2][col])
            {
                winner=gameCanvas.slots[0][col];
            }
        }

        if(gameCanvas.slots[0][0]==gameCanvas.slots[1][1] && gameCanvas.slots[1][1]==gameCanvas.slots[2][2])
        {
            winner=gameCanvas.slots[0][0];
        }

        if(gameCanvas.slots[2][0]==gameCanvas.slots[1][1] && gameCanvas.slots[1][1]==gameCanvas.slots[0][2])
        {
            winner=gameCanvas.slots[2][0];
        }

        return winner;
    }


}
